source: installer/opengnsys_installer.sh @ 27dc5ff

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 27dc5ff was db3f8a3, checked in by ramon <ramongomez@…>, 14 years ago

Versión 1.0.2: corregir erratas en instalador para detectar interfaces de red y en enlaces de ficheros (modificar #410).

git-svn-id: https://opengnsys.es/svn/branches/version1.0@2023 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 41.6 KB
RevLine 
[a01156a]1#!/bin/bash
2
3#####################################################################
4####### Script instalador OpenGnsys
5####### autor: Luis Guillén <lguillen@unizar.es>
6#####################################################################
7
8
[1e7eaab]9
[8fc9552]10####  AVISO: Editar configuración de acceso por defecto a la Base de Datos.
[4a3cd1f]11MYSQL_ROOT_PASSWORD="passwordroot"      # Clave root de MySQL
12OPENGNSYS_DATABASE="ogAdmBD"            # Nombre de la base datos
13OPENGNSYS_DB_USER="usuog"               # Usuario de acceso
14OPENGNSYS_DB_PASSWD="passusuog"         # Clave del usuario
15
[8fc9552]16####  AVISO: NO EDITAR.
17#### configuración de acceso smb para clientes OG.
18OPENGNSYS_CLIENT_USER="opengnsys"               # Nombre del usuario
19OPENGNSYS_CLIENT_PASSWD="og"            # Clave del usuario opengnsys
20
21
[4a3cd1f]22
[1e7eaab]23# Sólo ejecutable por usuario root
24if [ "$(whoami)" != 'root' ]
25then
26        echo "ERROR: this program must run under root privileges!!"
27        exit 1
28fi
29
[c1e00e4]30# Detectar sistema operativo del servidor (debe soportar LSB).
31OSDISTRIB=$(lsb_release -is 2>/dev/null)
32# Array con las dependencias que deben estar instaladas, según de la distribución detectada.
33case "$OSDISTRIB" in
34        Ubuntu) DEPENDENCIES=( subversion apache2 php5 libapache2-mod-php5 mysql-server php5-mysql nfs-kernel-server dhcp3-server bittorrent tftp-hpa tftpd-hpa syslinux openbsd-inetd update-inetd build-essential g++-multilib libmysqlclient15-dev wget doxygen graphviz bittornado ctorrent samba unzip netpipes debootstrap schroot squashfs-tools )
35                ;;
36        *)      echo "ERROR: Distribution not supported by OpenGnSys."
37                exit 1 ;;
38esac
39
[1e7eaab]40# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
[49c6891]41PROGRAMDIR=$(readlink -e $(dirname "$0"))
[07c3a59]42OPENGNSYS_SERVER="www.opengnsys.es"
[1e7eaab]43if [ -d "$PROGRAMDIR/../installer" ]; then
44    USESVN=0
45else
46    USESVN=1
47fi
[eb9424f]48SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.0/"
[1e7eaab]49
[a01156a]50WORKDIR=/tmp/opengnsys_installer
[1e7eaab]51mkdir -p $WORKDIR
52
53INSTALL_TARGET=/opt/opengnsys
[13a01a7]54LOG_FILE=/tmp/opengnsys_installation.log
[a01156a]55
[4a3cd1f]56# Base de datos
[7510561]57OPENGNSYS_DB_CREATION_FILE=opengnsys/admin/Database/ogAdmBD.sql
[3aaf91d]58
[a01156a]59
60#####################################################################
61####### Algunas funciones útiles de propósito general:
62#####################################################################
[13a01a7]63function getDateTime()
[a01156a]64{
[e0edc14]65        date "+%Y%m%d-%H%M%S"
[a01156a]66}
67
68# Escribe a fichero y muestra por pantalla
[13a01a7]69function echoAndLog()
[a01156a]70{
[e0edc14]71        echo "$1"
[a01156a]72        FECHAHORA=`getDateTime`
73        echo "$FECHAHORA;$SSH_CLIENT;$1" >> $LOG_FILE
74}
75
[13a01a7]76function errorAndLog()
[a01156a]77{
78        echo "ERROR: $1"
79        FECHAHORA=`getDateTime`
80        echo "$FECHAHORA;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
81}
82
83# comprueba si el elemento pasado en $2 esta en el array $1
[13a01a7]84function isInArray()
[a01156a]85{
86        if [ $# -ne 2 ]; then
[13a01a7]87                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]88                exit 1
89        fi
90
[13a01a7]91        echoAndLog "${FUNCNAME}(): checking if $2 is in $1"
[a01156a]92        local deps
[5c33840]93        eval "deps=( \"\${$1[@]}\" )"
[a01156a]94        elemento=$2
95
96        local is_in_array=1
97        # copia local del array del parametro 1
98        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
99        do
100                if [ "${deps[$i]}" = "${elemento}" ]; then
101                        echoAndLog "isInArray(): $elemento found in array"
102                        is_in_array=0
103                fi
104        done
105
106        if [ $is_in_array -ne 0 ]; then
[13a01a7]107                echoAndLog "${FUNCNAME}(): $elemento NOT found in array"
[a01156a]108        fi
109
110        return $is_in_array
111
112}
113
114#####################################################################
115####### Funciones de manejo de paquetes Debian
116#####################################################################
117
[13a01a7]118function checkPackage()
[a01156a]119{
120        package=$1
121        if [ -z $package ]; then
[73cfa0a]122                errorAndLog "${FUNCNAME}(): parameter required"
[a01156a]123                exit 1
124        fi
[73cfa0a]125        echoAndLog "${FUNCNAME}(): checking if package $package exists"
[da8db11]126        dpkg -s $package &>/dev/null | grep Status | grep -qw install
[a01156a]127        if [ $? -eq 0 ]; then
[73cfa0a]128                echoAndLog "${FUNCNAME}(): package $package exists"
[a01156a]129                return 0
130        else
[73cfa0a]131                echoAndLog "${FUNCNAME}(): package $package doesn't exists"
[a01156a]132                return 1
133        fi
134}
135
136# recibe array con dependencias
137# por referencia deja un array con las dependencias no resueltas
138# devuelve 1 si hay alguna dependencia no resuelta
[13a01a7]139function checkDependencies()
[a01156a]140{
141        if [ $# -ne 2 ]; then
[73cfa0a]142                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]143                exit 1
144        fi
145
[73cfa0a]146        echoAndLog "${FUNCNAME}(): checking dependences"
[a01156a]147        uncompletedeps=0
148
149        # copia local del array del parametro 1
150        local deps
[5c33840]151        eval "deps=( \"\${$1[@]}\" )"
[a01156a]152
153        declare -a local_notinstalled
[5c33840]154
[a01156a]155        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
156        do
157                checkPackage ${deps[$i]}
158                if [ $? -ne 0 ]; then
159                        local_notinstalled[$uncompletedeps]=$package
160                        let uncompletedeps=uncompletedeps+1
161                fi
162        done
163
164        # relleno el array especificado en $2 por referencia
165        for (( i = 0 ; i < ${#local_notinstalled[@]} ; i++ ))
166        do
167                eval "${2}[$i]=${local_notinstalled[$i]}"
168        done
169
170        # retorna el numero de paquetes no resueltos
[73cfa0a]171        echoAndLog "${FUNCNAME}(): dependencies uncompleted: $uncompletedeps"
[a01156a]172        return $uncompletedeps
173}
174
175# Recibe un array con las dependencias y lo instala
[13a01a7]176function installDependencies()
[a01156a]177{
178        if [ $# -ne 1 ]; then
[813f617]179                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]180                exit 1
181        fi
[813f617]182        echoAndLog "${FUNCNAME}(): installing uncompleted dependencies"
[a01156a]183
184        # copia local del array del parametro 1
185        local deps
[5c33840]186        eval "deps=( \"\${$1[@]}\" )"
[a01156a]187
188        local string_deps=""
189        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
190        do
191                string_deps="$string_deps ${deps[$i]}"
192        done
193
194        if [ -z "${string_deps}" ]; then
[813f617]195                errorAndLog "${FUNCNAME}(): array of dependeces is empty"
[a01156a]196                exit 1
197        fi
198
199        OLD_DEBIAN_FRONTEND=$DEBIAN_FRONTEND
200        export DEBIAN_FRONTEND=noninteractive
201
[813f617]202        echoAndLog "${FUNCNAME}(): now ${string_deps} will be installed"
[a01156a]203        apt-get -y install --force-yes ${string_deps}
204        if [ $? -ne 0 ]; then
[813f617]205                errorAndLog "${FUNCNAME}(): error installing dependencies"
[a01156a]206                return 1
207        fi
208
209        DEBIAN_FRONTEND=$OLD_DEBIAN_FRONTEND
[813f617]210        echoAndLog "${FUNCNAME}(): dependencies installed"
[a01156a]211}
212
[13a01a7]213# Hace un backup del fichero pasado por parámetro
214# deja un -last y uno para el día
215function backupFile()
216{
217        if [ $# -ne 1 ]; then
218                errorAndLog "${FUNCNAME}(): invalid number of parameters"
219                exit 1
220        fi
221
222        local fichero=$1
223        local fecha=`date +%Y%m%d`
224
225        if [ ! -f $fichero ]; then
226                errorAndLog "${FUNCNAME}(): file $fichero doesn't exists"
227                return 1
228        fi
229
230        echoAndLog "${FUNCNAME}(): realizando backup de $fichero"
231
232        # realiza una copia de la última configuración como last
233        cp -p $fichero "${fichero}-LAST"
234
235        # si para el día no hay backup lo hace, sino no
236        if [ ! -f "${fichero}-${fecha}" ]; then
237                cp -p $fichero "${fichero}-${fecha}"
238        fi
239
240        echoAndLog "${FUNCNAME}(): backup realizado"
241}
242
[a01156a]243#####################################################################
244####### Funciones para el manejo de bases de datos
245#####################################################################
246
247# This function set password to root
[13a01a7]248function mysqlSetRootPassword()
[a01156a]249{
250        if [ $# -ne 1 ]; then
[813f617]251                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]252                exit 1
253        fi
254
[e0edc14]255        local root_mysql="$1"
[813f617]256        echoAndLog "${FUNCNAME}(): setting root password in MySQL server"
[e0edc14]257        mysqladmin -u root password "$root_mysql"
[a01156a]258        if [ $? -ne 0 ]; then
[813f617]259                errorAndLog "${FUNCNAME}(): error while setting root password in MySQL server"
[a01156a]260                return 1
261        fi
[813f617]262        echoAndLog "${FUNCNAME}(): root password saved!"
[a01156a]263        return 0
264}
265
[892606b9]266# Si el servicio mysql esta ya instalado cambia la variable de la clave del root por la ya existente
[e0edc14]267function mysqlGetRootPassword()
268{
[892606b9]269        local pass_mysql
270        local pass_mysql2
[7c54b49]271        # Comprobar si MySQL está instalado con la clave de root por defecto.
272        if mysql -u root -p"$MYSQL_ROOT_PASSWORD" <<<"quit" 2>/dev/null; then
273                echoAndLog "${FUNCNAME}(): Using default mysql root password."
274        else
275                stty -echo
[e0edc14]276                echo "There is a MySQL service already installed."
277                read -p "Enter MySQL root password: " pass_mysql
[7c54b49]278                echo ""
[e0edc14]279                read -p "Confrim password:" pass_mysql2
[7c54b49]280                echo ""
281                stty echo
282                if [ "$pass_mysql" == "$pass_mysql2" ] ;then
[e0edc14]283                        MYSQL_ROOT_PASSWORD="$pass_mysql"
[7c54b49]284                        return 0
285                else
[e0edc14]286                        echo "The keys don't match. Do not configure the server's key,"
287                        echo "transactions in the database will give error."
[7c54b49]288                        return 1
289                fi
[892606b9]290        fi
291}
292
[a01156a]293# comprueba si puede conectar con mysql con el usuario root
294function mysqlTestConnection()
295{
296        if [ $# -ne 1 ]; then
[e0edc14]297                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]298                exit 1
299        fi
300
301        local root_password="${1}"
[e0edc14]302        echoAndLog "${FUNCNAME}(): checking connection to mysql..."
[a01156a]303        echo "" | mysql -uroot -p"${root_password}"
304        if [ $? -ne 0 ]; then
[e0edc14]305                errorAndLog "${FUNCNAME}(): connection to mysql failed, check root password and if daemon is running!"
[a01156a]306                return 1
307        else
[e0edc14]308                echoAndLog "${FUNCNAME}(): connection success"
[a01156a]309                return 0
310        fi
311}
312
313# comprueba si la base de datos existe
314function mysqlDbExists()
315{
316        if [ $# -ne 2 ]; then
[e0edc14]317                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]318                exit 1
319        fi
320
321        local root_password="${1}"
322        local database=$2
[e0edc14]323        echoAndLog "${FUNCNAME}(): checking if $database exists..."
[a01156a]324        echo "show databases" | mysql -uroot -p"${root_password}" | grep "^${database}$"
325        if [ $? -ne 0 ]; then
[e0edc14]326                echoAndLog "${FUNCNAME}():database $database doesn't exists"
[a01156a]327                return 1
328        else
[e0edc14]329                echoAndLog "${FUNCNAME}():database $database exists"
[a01156a]330                return 0
331        fi
332}
333
334function mysqlCheckDbIsEmpty()
335{
336        if [ $# -ne 2 ]; then
[e0edc14]337                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]338                exit 1
339        fi
340
341        local root_password="${1}"
342        local database=$2
[e0edc14]343        echoAndLog "${FUNCNAME}(): checking if $database is empty..."
[a01156a]344        num_tablas=`echo "show tables" | mysql -uroot -p"${root_password}" "${database}" | wc -l`
345        if [ $? -ne 0 ]; then
[e0edc14]346                errorAndLog "${FUNCNAME}(): error executing query, check database and root password"
[a01156a]347                exit 1
348        fi
349
350        if [ $num_tablas -eq 0 ]; then
[e0edc14]351                echoAndLog "${FUNCNAME}():database $database is empty"
[a01156a]352                return 0
353        else
[e0edc14]354                echoAndLog "${FUNCNAME}():database $database has tables"
[a01156a]355                return 1
356        fi
357
358}
359
360
361function mysqlImportSqlFileToDb()
362{
363        if [ $# -ne 3 ]; then
[c5ce04c]364                errorAndLog "${FNCNAME}(): invalid number of parameters"
[a01156a]365                exit 1
366        fi
367
[c4321ae]368        local root_password="$1"
369        local database="$2"
370        local sqlfile="$3"
371        local tmpfile=$(mktemp)
372        local status
[a01156a]373
374        if [ ! -f $sqlfile ]; then
[c5ce04c]375                errorAndLog "${FUNCNAME}(): Unable to locate $sqlfile!!"
[a01156a]376                return 1
377        fi
378
[c5ce04c]379        echoAndLog "${FUNCNAME}(): importing sql file to ${database}..."
[c4321ae]380        chmod 600 $tmpfile
381        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
382            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" $sqlfile > $tmpfile
383        mysql -uroot -p"${root_password}" --default-character-set=utf8 "${database}" < $tmpfile
384        status=$?
385        rm -f $tmpfile
386        if [ $status -ne 0 ]; then
[c5ce04c]387                errorAndLog "${FUNCNAME}(): error while importing $sqlfile in database $database"
[a01156a]388                return 1
389        fi
[c5ce04c]390        echoAndLog "${FUNCNAME}(): file imported to database $database"
[a01156a]391        return 0
392}
393
394# Crea la base de datos
395function mysqlCreateDb()
396{
397        if [ $# -ne 2 ]; then
[a555f49]398                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]399                exit 1
400        fi
401
402        local root_password="${1}"
403        local database=$2
404
[a555f49]405        echoAndLog "${FUNCNAME}(): creating database..."
[a01156a]406        mysqladmin -u root --password="${root_password}" create $database
407        if [ $? -ne 0 ]; then
[a555f49]408                errorAndLog "${FUNCNAME}(): error while creating database $database"
[a01156a]409                return 1
410        fi
[a555f49]411        echoAndLog "${FUNCNAME}(): database $database created"
[a01156a]412        return 0
413}
414
415
416function mysqlCheckUserExists()
417{
418        if [ $# -ne 2 ]; then
[e0edc14]419                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]420                exit 1
421        fi
422
423        local root_password="${1}"
424        local userdb=$2
425
[e0edc14]426        echoAndLog "${FUNCNAME}(): checking if $userdb exists..."
[a01156a]427        echo "select user from user where user='${userdb}'\\G" |mysql -uroot -p"${root_password}" mysql | grep user
428        if [ $? -ne 0 ]; then
[e0edc14]429                echoAndLog "${FUNCNAME}(): user doesn't exists"
[a01156a]430                return 1
431        else
[e0edc14]432                echoAndLog "${FUNCNAME}(): user already exists"
[a01156a]433                return 0
434        fi
435
436}
437
438# Crea un usuario administrativo para la base de datos
439function mysqlCreateAdminUserToDb()
440{
441        if [ $# -ne 4 ]; then
[e0edc14]442                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]443                exit 1
444        fi
445
446        local root_password=$1
447        local database=$2
448        local userdb=$3
449        local passdb=$4
450
[e0edc14]451        echoAndLog "${FUNCNAME}(): creating admin user ${userdb} to database ${database}"
[a01156a]452
453        cat > $WORKDIR/create_${database}.sql <<EOF
454GRANT USAGE ON *.* TO '${userdb}'@'localhost' IDENTIFIED BY '${passdb}' ;
455GRANT ALL PRIVILEGES ON ${database}.* TO '${userdb}'@'localhost' WITH GRANT OPTION ;
456FLUSH PRIVILEGES ;
457EOF
458        mysql -u root --password=${root_password} < $WORKDIR/create_${database}.sql
459        if [ $? -ne 0 ]; then
[e0edc14]460                errorAndLog "${FUNCNAME}(): error while creating user in mysql"
[a01156a]461                rm -f $WORKDIR/create_${database}.sql
462                return 1
463        else
[e0edc14]464                echoAndLog "${FUNCNAME}(): user created ok"
[a01156a]465                rm -f $WORKDIR/create_${database}.sql
466                return 0
467        fi
468}
469
470
471#####################################################################
472####### Funciones para el manejo de Subversion
473#####################################################################
474
[13a01a7]475function svnExportCode()
476{
477        if [ $# -ne 1 ]; then
478                errorAndLog "${FUNCNAME}(): invalid number of parameters"
479                exit 1
480        fi
481
[6090a2d]482        local url="$1"
[13a01a7]483
484        echoAndLog "${FUNCNAME}(): downloading subversion code..."
485
[6090a2d]486        svn export --force "$url" opengnsys
[13a01a7]487        if [ $? -ne 0 ]; then
[6090a2d]488                errorAndLog "${FUNCNAME}(): error getting OpenGnSys code from $url"
[13a01a7]489                return 1
490        fi
491        echoAndLog "${FUNCNAME}(): subversion code downloaded"
492        return 0
493}
494
495
[892606b9]496############################################################
[7586ca3]497###  Detectar red
498############################################################
499
[07c3a59]500# Comprobar si existe conexión.
501function checkNetworkConnection()
502{
503        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
504        wget --spider -q $OPENGNSYS_SERVER
505}
506
507# Obtener los parámetros de red de la interfaz por defecto.
[7586ca3]508function getNetworkSettings()
509{
[d808c36]510        # Variables globales definidas:
511        # - SERVERIP: IP local del servidor.
512        # - NETIP:    IP de la red.
513        # - NETMASK:  máscara de red.
514        # - NETBROAD: IP de difusión de la red.
515        # - ROUTERIP: IP del router.
516        # - DNSIP:    IP del servidor DNS.
517
518        local MAINDEV
519
520        echoAndLog "${FUNCNAME}(): Detecting default network parameters."
521        MAINDEV=$(ip -o link show up | awk '!/loopback/ {d=d$2} END {sub(/:.*/,"",d); print d}')
522        if [ -z "$MAINDEV" ]; then
523                errorAndLog "${FUNCNAME}(): Network device not detected."
[62e3bcf]524                exit 1
525        fi
[d808c36]526        SERVERIP=$(ip -o addr show dev $MAINDEV | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
527        NETMASK=$(LANG=C ifconfig $MAINDEV | awk '/Mask/ {sub(/.*:/,"",$4); print $4}')
528        NETBROAD=$(ip -o addr show dev $MAINDEV | awk '$3~/inet$/ {print ($6)}')
529        NETIP=$(netstat -nr | grep $MAINDEV | awk '$1!~/0\.0\.0\.0/ {if (n=="") n=$1} END {print n}')
530        ROUTERIP=$(netstat -nr | awk '$1~/0\.0\.0\.0/ {print $2}')
[a555f49]531        DNSIP=$(awk '/nameserver/ {print $2}' /etc/resolv.conf | head -n1)
[d808c36]532        if [ -z "$NETIP" -o -z "$NETMASK" ]; then
[62e3bcf]533                errorAndLog "${FUNCNAME}(): Network not detected."
[7586ca3]534                exit 1
535        fi
[cc7eab7]536
537        # Variables de ejecución de Apache
538        # - APACHE_RUN_USER
539        # - APACHE_RUN_GROUP
540        if [ -f /etc/apache2/envvars ]; then
541                source /etc/apache2/envvars
542        fi
543        APACHE_RUN_USER=${APACHE_RUN_USER:-"www-data"}
544        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"www-data"}
[7586ca3]545}
546
547
548############################################################
[892606b9]549### Esqueleto para el Servicio pxe y contenedor tftpboot ###
550############################################################
551
[e0edc14]552function tftpConfigure()
553{
554        echoAndLog "${FUNCNAME}(): Configuring TFTP service."
[892606b9]555        basetftp=/var/lib/tftpboot
556
557        # reiniciamos demonio internet ????? porque ????
558        /etc/init.d/openbsd-inetd start
559
560        # preparacion contenedor tftpboot
561        cp -pr /usr/lib/syslinux/ ${basetftp}/syslinux
562        cp /usr/lib/syslinux/pxelinux.0 ${basetftp}
563        # prepamos el directorio de la configuracion de pxe
564        mkdir -p ${basetftp}/pxelinux.cfg
565        cat > ${basetftp}/pxelinux.cfg/default <<EOF
[8fc9552]566DEFAULT syslinux/vesamenu.c32
567MENU TITLE Aplicacion GNSYS
568 
569LABEL 1
570MENU LABEL 1
571KERNEL syslinux/chain.c32
572APPEND hd0
573 
574PROMPT 0
575TIMEOUT 10
[892606b9]576EOF
577        # comprobamos el servicio tftp
578        sleep 1
579        testPxe
580        ## damos perfimos de lectura a usuario web.
[cc7eab7]581        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP ${basetftp}
[892606b9]582}
583
[e0edc14]584function testPxe ()
585{
586        echoAndLog "${FUNCNAME}(): Checking TFTP service... please wait."
[892606b9]587        cd /tmp
[e0edc14]588        tftp -v localhost -c get pxelinux.0 /tmp/pxelinux.0 && echoAndLog "TFTP service is OK." || errorAndLog "TFTP service is down."
[892606b9]589        cd /
590}
591
[8fc9552]592
[892606b9]593########################################################################
[d808c36]594## Configuracion servicio NFS
595########################################################################
596
597# ADVERTENCIA: usa variables globales NETIP y NETMASK!
598function nfsConfigure()
599{
600        echoAndLog "${FUNCNAME}(): Config nfs server."
601
602        backupFile /etc/exports
603
604        nfsAddExport /opt/opengnsys/client ${NETIP}/${NETMASK}:ro,no_subtree_check,no_root_squash,sync
605        if [ $? -ne 0 ]; then
606                errorAndLog "${FUNCNAME}(): error while adding nfs client config"
607                return 1
608        fi
609
610        nfsAddExport /opt/opengnsys/images ${NETIP}/${NETMASK}:rw,no_subtree_check,no_root_squash,sync,crossmnt
611        if [ $? -ne 0 ]; then
612                errorAndLog "${FUNCNAME}(): error while adding nfs images config"
613                return 1
614        fi
615
616        nfsAddExport /opt/opengnsys/log/clients ${NETIP}/${NETMASK}:rw,no_subtree_check,no_root_squash,sync
617        if [ $? -ne 0 ]; then
618                errorAndLog "${FUNCNAME}(): error while adding logging client config"
619                return 1
620        fi
621
622        nfsAddExport /var/lib/tftpboot ${NETIP}/${NETMASK}:ro,no_subtree_check,no_root_squash,sync
623        if [ $? -ne 0 ]; then
624                errorAndLog "${FUNCNAME}(): error while adding second filesystem for the pxe ogclient"
625                return 1
626        fi
627
628        /etc/init.d/nfs-kernel-server restart
629
630        exportfs -va
631        if [ $? -ne 0 ]; then
632                errorAndLog "${FUNCNAME}(): error while configure exports"
633                return 1
634        fi
635
636        echoAndLog "${FUNCNAME}(): Added NFS configuration to file \"/etc/exports\"."
637        return 0
638}
639
640
641# ejemplos:
642#nfsAddExport /opt/opengnsys 192.168.0.0/255.255.255.0:ro,no_subtree_check,no_root_squash,sync
643#nfsAddExport /opt/opengnsys 192.168.0.0/255.255.255.0
644#nfsAddExport /opt/opengnsys 80.20.2.1:ro 192.123.32.2:rw
645function nfsAddExport()
646{
647        if [ $# -lt 2 ]; then
648                errorAndLog "${FUNCNAME}(): invalid number of parameters"
649                exit 1
650        fi
651
652        if [ ! -f /etc/exports ]; then
653                errorAndLog "${FUNCNAME}(): /etc/exports don't exists"
654                return 1
655        fi
656
657        local export="${1}"
658        local contador=0
659        local cadenaexport
660
661        grep "^${export}" /etc/exports > /dev/null
662        if [ $? -eq 0 ]; then
663                echoAndLog "${FUNCNAME}(): $export exists in /etc/exports, omiting"
664                return 0
665        fi
666
667        cadenaexport="${export}"
668        for parametro in $*
669        do
670                if [ $contador -gt 0 ]
671                then
672                        host=`echo $parametro | awk -F: '{print $1}'`
673                        options=`echo $parametro | awk -F: '{print $2}'`
674                        if [ "${host}" == "" ]; then
675                                errorAndLog "${FUNCNAME}(): host can't be empty"
676                                return 1
677                        fi
678                        cadenaexport="${cadenaexport}\t${host}"
679
680                        if [ "${options}" != "" ]; then
681                                cadenaexport="${cadenaexport}(${options})"
682                        fi
683                fi
684                let contador=contador+1
685        done
686
687        echo -en "$cadenaexport\n" >> /etc/exports
688
689        echoAndLog "${FUNCNAME}(): add $export to /etc/exports"
690
691        return 0
692}
693
694
695########################################################################
[813f617]696## Configuracion servicio Samba
[8fc9552]697########################################################################
698function smbConfigure()
699{
[e0edc14]700        echoAndLog "${FUNCNAME}(): Configuring Samba service."
[8fc9552]701
702        backupFile /etc/samba/smb.conf
703       
[813f617]704        # Copiar plantailla de recursos para OpenGnSys
[c1e00e4]705        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
[edac247]706                $WORKDIR/opengnsys/server/etc/smb-og.conf.tmpl > /etc/samba/smb-og.conf
[813f617]707        # Configurar y recargar Samba"
[edac247]708        perl -pi -e "s/WORKGROUP/OPENGNSYS/; s/server string \=.*/server string \= OpenGnSys Samba Server/; s/^\; *include \=.*$/   include \= \/etc\/samba\/smb-og.conf/" /etc/samba/smb.conf
[813f617]709        /etc/init.d/smbd restart
[8fc9552]710        if [ $? -ne 0 ]; then
[813f617]711                errorAndLog "${FUNCNAME}(): error while configure Samba"
[8fc9552]712                return 1
713        fi
[eb9424f]714        # Crear clave para usuario de acceso a los recursos.
[813f617]715        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | smbpasswd -a -s $OPENGNSYS_CLIENT_USER
[8fc9552]716
[813f617]717        echoAndLog "${FUNCNAME}(): Added Samba configuration."
[8fc9552]718        return 0
719}
720
721
[b6906f7]722########################################################################
723## Configuracion servicio DHCP
724########################################################################
725
[7586ca3]726function dhcpConfigure()
727{
[836a7597]728        echoAndLog "${FUNCNAME}(): Sample DHCP configuration."
[a555f49]729
[b25fc47]730        local DHCPSERVER=/etc/init.d/isc-dhcp-server
[db3f8a3]731        DHCPCONFIG=/etc/dhcp/dhcpd.conf
[b25fc47]732        if [ ! -x $DHCPSERVER ]; then
733                DHCPSERVER=/etc/init.d/dhcp3-server
734                DHCPCONFIG=/etc/dhcp3/dhcpd.conf
735        fi
736        backupFile $DHCPCONFIG
[d808c36]737
[b25fc47]738        sed -e "s/SERVERIP/$SERVERIP/g" \
[d808c36]739            -e "s/NETIP/$NETIP/g" \
740            -e "s/NETMASK/$NETMASK/g" \
741            -e "s/NETBROAD/$NETBROAD/g" \
742            -e "s/ROUTERIP/$ROUTERIP/g" \
743            -e "s/DNSIP/$DNSIP/g" \
[b25fc47]744            $WORKDIR/opengnsys/server/etc/dhcpd.conf.tmpl > $DHCPCONFIG
[a555f49]745        if [ $? -ne 0 ]; then
[b25fc47]746                errorAndLog "${FUNCNAME}(): error while configuring DHCP server"
[a555f49]747                return 1
748        fi
[d808c36]749
[b25fc47]750        $DHCPSERVER restart
751        echoAndLog "${FUNCNAME}(): Sample DHCP configured in file \"$DHCPCONFIG\"."
[a555f49]752        return 0
[892606b9]753}
754
755
[a01156a]756#####################################################################
757####### Funciones específicas de la instalación de Opengnsys
758#####################################################################
759
[49c6891]760# Copiar ficheros del OpenGnSys Web Console.
[7586ca3]761function installWebFiles()
762{
[dce072b]763        echoAndLog "${FUNCNAME}(): Installing web files..."
[7586ca3]764        cp -ar $WORKDIR/opengnsys/admin/WebConsole/* $INSTALL_TARGET/www   #*/ comentario para doxigen
765        if [ $? != 0 ]; then
[dce072b]766                errorAndLog "${FUNCNAME}(): Error copying web files."
[7586ca3]767                exit 1
768        fi
769        find $INSTALL_TARGET/www -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[813f617]770        # Descomprimir XAJAX.
[edac247]771        unzip $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
[7586ca3]772        # Cambiar permisos para ficheros especiales.
[3aaf91d]773        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/iconos
[dce072b]774        echoAndLog "${FUNCNAME}(): Web files installed successfully."
[7586ca3]775}
776
777# Configuración específica de Apache.
[892606b9]778function openGnsysInstallWebConsoleApacheConf()
[a01156a]779{
780        if [ $# -ne 2 ]; then
[dce072b]781                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]782                exit 1
783        fi
784
785        local path_opengnsys_base=$1
786        local path_apache2_confd=$2
[892606b9]787        local path_web_console=${path_opengnsys_base}/www
[a01156a]788
[892606b9]789        if [ ! -d $path_apache2_confd ]; then
[dce072b]790                errorAndLog "${FUNCNAME}(): path to apache2 conf.d can not found, verify your server installation"
[892606b9]791                return 1
792        fi
793
[7586ca3]794        mkdir -p $path_apache2_confd/{sites-available,sites-enabled}
[892606b9]795
[dce072b]796        echoAndLog "${FUNCNAME}(): creating apache2 config file.."
[a01156a]797
[d725a41]798
[a01156a]799        # genera configuración
[892606b9]800        cat > $path_opengnsys_base/etc/apache.conf <<EOF
[49c6891]801# OpenGnSys Web Console configuration for Apache
[a01156a]802
[892606b9]803Alias /opengnsys ${path_web_console}
[a01156a]804
[892606b9]805<Directory ${path_web_console}>
[a01156a]806        Options -Indexes FollowSymLinks
807        DirectoryIndex acceso.php
808</Directory>
809EOF
810
[7586ca3]811        ln -fs $path_opengnsys_base/etc/apache.conf $path_apache2_confd/sites-available/opengnsys.conf
812        ln -fs $path_apache2_confd/sites-available/opengnsys.conf $path_apache2_confd/sites-enabled/opengnsys.conf
[a01156a]813        if [ $? -ne 0 ]; then
[dce072b]814                errorAndLog "${FUNCNAME}(): config file can't be linked to apache conf, verify your server installation"
[a01156a]815                return 1
816        else
[dce072b]817                echoAndLog "${FUNCNAME}(): config file created and linked, restarting apache daemon"
[077dd7c5]818                /etc/init.d/apache2 restart
[a01156a]819                return 0
820        fi
821}
822
[8fc9552]823
[5d6bf97]824# Crear documentación Doxygen para la consola web.
825function makeDoxygenFiles()
826{
827        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
828        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
829                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
830        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
831                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
[ead38fb]832                return 1
[5d6bf97]833        fi
834        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
835        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
836        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
837}
838
839
[a01156a]840# Crea la estructura base de la instalación de opengnsys
[eb9424f]841function createDirs()
[a01156a]842{
843        if [ $# -ne 1 ]; then
[dce072b]844                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]845                exit 1
846        fi
847
[eb9424f]848        local path_opengnsys_base="$1"
[a01156a]849
[eb9424f]850        # Crear estructura de directorios.
[dce072b]851        echoAndLog "${FUNCNAME}(): creating directory paths in $path_opengnsys_base"
[a01156a]852        mkdir -p $path_opengnsys_base
853        mkdir -p $path_opengnsys_base/bin
[5c33840]854        mkdir -p $path_opengnsys_base/client
[49c6891]855        mkdir -p $path_opengnsys_base/doc
[5c33840]856        mkdir -p $path_opengnsys_base/etc
[a01156a]857        mkdir -p $path_opengnsys_base/lib
[1cc5697]858        mkdir -p $path_opengnsys_base/log/clients
[eb9424f]859        ln -fs $path_opengnsys_base/log /var/log/opengnsys
[7586ca3]860        mkdir -p $path_opengnsys_base/sbin
[a01156a]861        mkdir -p $path_opengnsys_base/www
[5c33840]862        mkdir -p $path_opengnsys_base/images
[b6906f7]863        ln -fs /var/lib/tftpboot $path_opengnsys_base
[eb9424f]864        mkdir -p $path_opengnsys_base/tftpboot/pxelinux.cfg
[a01156a]865        if [ $? -ne 0 ]; then
[dce072b]866                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
[a01156a]867                return 1
868        fi
869
[eb9424f]870        # Crear usuario ficticio.
871        if id -u $OPENGNSYS_CLIENT_USER &>/dev/null; then
872                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENT_USER\" is already created"
873        else
874                echoAndLog "${FUNCNAME}(): creating OpenGnSys user"
875                useradd $OPENGNSYS_CLIENT_USER 2>/dev/null
876                if [ $? -ne 0 ]; then
877                        errorAndLog "${FUNCNAME}(): error creating OpenGnSys user"
878                        return 1
879                fi
880        fi
881
882        # Establecer los permisos básicos.
883        echoAndLog "${FUNCNAME}(): setting directory permissions"
884        chmod -R 775 $path_opengnsys_base/{log/clients,images,tftpboot/pxelinux.cfg}
885        chown -R :$OPENGNSYS_CLIENT_USER $path_opengnsys_base/{log/clients,images,tftpboot/pxelinux.cfg}
886        if [ $? -ne 0 ]; then
887                errorAndLog "${FUNCNAME}(): error while setting permissions"
888                return 1
889        fi
890
[dce072b]891        echoAndLog "${FUNCNAME}(): directory paths created"
[a01156a]892        return 0
893}
894
[463a1d49]895# Copia ficheros de configuración y ejecutables genéricos del servidor.
[e0edc14]896function openGnsysCopyServerFiles ()
897{
[463a1d49]898        if [ $# -ne 1 ]; then
[879689f]899                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[463a1d49]900                exit 1
901        fi
902
[7caf5a7c]903        local path_opengnsys_base="$1"
[463a1d49]904
[2338c95f]905        local SOURCES=( server/tftpboot/pxelinux.cfg \
[7caf5a7c]906                        server/bin \
907                        repoman/bin \
908                        installer/opengnsys_uninstall.sh \
909                        installer/opengnsys_update.sh \
910                        doc )
[2338c95f]911        local TARGETS=( tftpboot/pxelinux.cfg \
[7caf5a7c]912                        bin \
913                        bin \
914                        lib \
915                        lib \
916                        doc )
[463a1d49]917
918        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
[879689f]919                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
[463a1d49]920                exit 1
921        fi
922
[879689f]923        echoAndLog "${FUNCNAME}(): copying files to server directories"
[f2bb433]924
[8457092]925        pushd $WORKDIR/opengnsys
[463a1d49]926        local i
927        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
928                if [ -f "${SOURCES[$i]}" ]; then
[879689f]929                        echoAndLog "Copying ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[b5aae72]930                        cp -a "${SOURCES[$i]}" "${path_opengnsys_base}/${TARGETS[$i]}"
[8457092]931                elif [ -d "${SOURCES[$i]}" ]; then
[879689f]932                        echoAndLog "Copying content of ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[8457092]933                        cp -a "${SOURCES[$i]}"/* "${path_opengnsys_base}/${TARGETS[$i]}"
934        else
935                        echoAndLog "Warning: Unable to copy ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[463a1d49]936                fi
937        done
[7586ca3]938        popd
[892606b9]939}
940
[7586ca3]941####################################################################
942### Funciones de compilación de códifo fuente de servicios
943####################################################################
944
[b6906f7]945# Compilar los servicios de OpenGNsys
[7586ca3]946function servicesCompilation ()
947{
[13a01a7]948        local hayErrores=0
[0795938]949
[49c6891]950        # Compilar OpenGnSys Server
951        echoAndLog "${FUNCNAME}(): Compiling OpenGnSys Admin Server"
[7b61735]952        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
[b6906f7]953        make && make install
[13a01a7]954        if [ $? -ne 0 ]; then
[49c6891]955                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Admin Server"
[13a01a7]956                hayErrores=1
957        fi
[7586ca3]958        popd
[49c6891]959        # Compilar OpenGnSys Repository Manager
960        echoAndLog "${FUNCNAME}(): Compiling OpenGnSys Repository Manager"
[7b61735]961        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
[b6906f7]962        make && make install
[13a01a7]963        if [ $? -ne 0 ]; then
[49c6891]964                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Repository Manager"
[13a01a7]965                hayErrores=1
966        fi
[8125e7c]967        popd
[4984660]968        # Compilar OpenGnSys Agent
969        echoAndLog "${FUNCNAME}(): Compiling OpenGnSys Agent"
[7b61735]970        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
[4984660]971        make && make install
972        if [ $? -ne 0 ]; then
973                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Agent"
974                hayErrores=1
975        fi
976        popd   
[49c6891]977        # Compilar OpenGnSys Client
978        echoAndLog "${FUNCNAME}(): Compiling OpenGnSys Admin Client"
[7b61735]979        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
[2338c95f]980        make && mv ogAdmClient ../../../../client/shared/bin
[13a01a7]981        if [ $? -ne 0 ]; then
[49c6891]982                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Admin Client"
[13a01a7]983                hayErrores=1
984        fi
[318efac]985        popd
[13a01a7]986
987        return $hayErrores
[b6906f7]988}
989
[7b61735]990####################################################################
991### Funciones de copia de la Interface de administración
992####################################################################
993
994# Copiar carpeta de Interface
[c1e00e4]995function copyInterfaceAdm ()
[7b61735]996{
997        local hayErrores=0
998       
[fbd9bcc]999        # Crear carpeta y copiar Interface
[7b61735]1000        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
[fbd9bcc]1001        cp -ar $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client/interfaceAdm
[7b61735]1002        if [ $? -ne 0 ]; then
1003                echoAndLog "${FUNCNAME}(): error while copying Administration Interface Folder"
1004                hayErrores=1
1005        fi
[b6f1726]1006        chown $OPENGNSYS_CLIENT_USER:$OPENGNSYS_CLIENT_USER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[f6c1d2b]1007        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[7b61735]1008
1009        return $hayErrores
1010}
[b6906f7]1011
[892606b9]1012####################################################################
1013### Funciones instalacion cliente opengnsys
1014####################################################################
1015
[7cc6687]1016function openGnsysCopyClientFiles()
[7586ca3]1017{
[a555f49]1018        local hayErrores=0
1019
[49c6891]1020        echoAndLog "${FUNCNAME}(): Copying OpenGnSys Client files."
[d47d38d]1021        cp -ar $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
1022        if [ $? -ne 0 ]; then
[9ef8920]1023                errorAndLog "${FUNCNAME}(): error while copying client estructure"
1024                hayErrores=1
1025        fi
[d47d38d]1026        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[9ef8920]1027       
[49c6891]1028        echoAndLog "${FUNCNAME}(): Copying OpenGnSys Cloning Engine files."
[d47d38d]1029        mkdir -p $INSTALL_TARGET/client/lib/engine/bin
1030        cp -ar $WORKDIR/opengnsys/client/engine/*.lib $INSTALL_TARGET/client/lib/engine/bin
[a555f49]1031        if [ $? -ne 0 ]; then
1032                errorAndLog "${FUNCNAME}(): error while copying engine files"
1033                hayErrores=1
1034        fi
[9ef8920]1035       
1036        if [ $hayErrores -eq 0 ]; then
1037                echoAndLog "${FUNCNAME}(): client copy files success."
1038        else
1039                errorAndLog "${FUNCNAME}(): client copy files with errors"
1040        fi
1041
1042        return $hayErrores
1043}
1044
1045
1046
1047
1048# Crear antiguo cliente initrd para OpenGnSys 0.10
1049function openGnsysOldClientCreate()
1050{
1051        local OSCODENAME
1052
1053        local hayErrores=0
1054
[cc7eab7]1055        # Cargar Kernel, Initrd y paquetes udeb para la distribución del servidor (o por defecto).
[28c96b3]1056        OSCODENAME=$(lsb_release -cs 2>/dev/null)
[7586ca3]1057        if [ "$OSDISTRIB" = "Ubuntu" -a -n "$OSCODENAME" ]; then
[a555f49]1058                echoAndLog "${FUNCNAME}(): Loading Kernel and Initrd files for $OSDISTRIB $OSCODENAME."
[da8db11]1059                $INSTALL_TARGET/bin/initrd-generator -t $INSTALL_TARGET/tftpboot -v $OSCODENAME 2>&1 | tee -a $LOG_FILE
[a555f49]1060                if [ $? -ne 0 ]; then
[49c6891]1061                        errorAndLog "${FUNCNAME}(): error while generating initrd OpenGnSys Admin Client"
[a555f49]1062                        hayErrores=1
1063                fi
1064                echoAndLog "${FUNCNAME}(): Loading udeb files for $OSDISTRIB $OSCODENAME."
[da8db11]1065                $INSTALL_TARGET/bin/upgrade-clients-udeb.sh $OSCODENAME 2>&1 | tee -a $LOG_FILE
[a555f49]1066                if [ $? -ne 0 ]; then
[49c6891]1067                        errorAndLog "${FUNCNAME}(): error while upgrading udeb files OpenGnSys Admin Client"
[a555f49]1068                        hayErrores=1
1069                fi
[7586ca3]1070        else
[a555f49]1071                echoAndLog "${FUNCNAME}(): Loading default Kernel and Initrd files."
[da8db11]1072                $INSTALL_TARGET/bin/initrd-generator -t $INSTALL_TARGET/tftpboot 2>&1 | tee -a $LOG_FILE
[a555f49]1073                if [ $? -ne 0 ]; then
[49c6891]1074                        errorAndLog "${FUNCNAME}(): error while generating initrd OpenGnSys Admin Client"
[a555f49]1075                        hayErrores=1
1076                fi
1077                echoAndLog "${FUNCNAME}(): Loading default udeb files."
[da8db11]1078                $INSTALL_TARGET/bin/upgrade-clients-udeb.sh 2>&1 | tee -a $LOG_FILE
[a555f49]1079                if [ $? -ne 0 ]; then
[49c6891]1080                        errorAndLog "${FUNCNAME}(): error while upgrading udeb files OpenGnSys Admin Client"
[a555f49]1081                        hayErrores=1
1082                fi
1083        fi
1084
1085        if [ $hayErrores -eq 0 ]; then
[813f617]1086                echoAndLog "${FUNCNAME}(): Old client generation success."
[a555f49]1087        else
[813f617]1088                errorAndLog "${FUNCNAME}(): Old client generation with errors"
[7586ca3]1089        fi
[a555f49]1090
1091        return $hayErrores
[463a1d49]1092}
1093
1094
[813f617]1095# Crear nuevo cliente OpenGnSys 1.0
1096function openGnsysClientCreate()
1097{
1098        local DOWNLOADURL=http://www.opengnsys.es/downloads
[e9722d2]1099        local FILENAME=ogclient-1.0.1-lucid-32bit.tar.gz
[6ef9f23]1100        local TMPFILE=/tmp/$FILENAME
[813f617]1101
1102        echoAndLog "${FUNCNAME}(): Loading Client"
1103        # Descargar y descomprimir cliente ogclient
[6ef9f23]1104        wget $DOWNLOADURL/$FILENAME -O $TMPFILE
1105        if [ ! -s $TMPFILE ]; then
1106                errorAndLog "${FUNCNAME}(): Error loading OpenGnSys Client"
[813f617]1107                return 1
1108        fi
1109        echoAndLog "${FUNCNAME}(): Extranting Client files"
[6ef9f23]1110        tar xzvf $TMPFILE -C $INSTALL_TARGET/tftpboot
1111        rm -f $TMPFILE
[813f617]1112        # Usar la versión más reciente del Kernel y del Initrd para el cliente.
[e0edc14]1113        ln -f $(ls $INSTALL_TARGET/tftpboot/ogclient/vmlinuz-*|tail -1) $INSTALL_TARGET/tftpboot/ogclient/ogvmlinuz
1114        ln -f $(ls $INSTALL_TARGET/tftpboot/ogclient/initrd.img-*|tail -1) $INSTALL_TARGET/tftpboot/ogclient/oginitrd.img
[813f617]1115        # Establecer los permisos.
1116        chmod -R 755 $INSTALL_TARGET/tftpboot/ogclient
1117        chown -R :$OPENGNSYS_CLIENT_USER $INSTALL_TARGET/tftpboot/ogclient
1118        echoAndLog "${FUNCNAME}(): Client generation success"
1119}
1120
1121
[49c6891]1122# Configuración básica de servicios de OpenGnSys
[cc7eab7]1123function openGnsysConfigure()
1124{
[9ee62ad]1125        echoAndLog "${FUNCNAME}(): Copying init files."
[7b61735]1126        cp -p $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
1127        cp -p $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys
[8fc9552]1128        cp -p $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepoAux /opt/opengnsys/sbin/
[cc7eab7]1129        update-rc.d opengnsys defaults
[9ee62ad]1130        echoAndLog "${FUNCNAME}(): Creating cron files."
1131        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
[8fc9552]1132        echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
[9ee62ad]1133        echoAndLog "${FUNCNAME}(): Creating OpenGnSys config file in \"$INSTALL_TARGET/etc\"."
[bf41d13]1134        perl -pi -e "s/SERVERIP/$SERVERIP/g; s/DBUSER/$OPENGNSYS_DB_USER/g; s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g; s/DATABASE/$OPENGNSYS_DATABASE/g" $INSTALL_TARGET/etc/ogAdmServer.cfg
[1a22cd2]1135        perl -pi -e "s/SERVERIP/$SERVERIP/g" $INSTALL_TARGET/etc/ogAdmRepo.cfg
[4a3cd1f]1136        perl -pi -e "s/SERVERIP/$SERVERIP/g; s/DBUSER/$OPENGNSYS_DB_USER/g; s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g; s/DATABASE/$OPENGNSYS_DATABASE/g" $INSTALL_TARGET/etc/ogAdmAgent.cfg
[9de73019]1137        chown root:root $INSTALL_TARGET/etc/{ogAdmServer.cfg,ogAdmAgent.cfg}
1138        chmod 600 $INSTALL_TARGET/etc/{ogAdmServer.cfg,ogAdmAgent.cfg}
[ea7186c]1139        echoAndLog "${FUNCNAME}(): Creating Web Console config file"
1140        OPENGNSYS_CONSOLEURL="http://$SERVERIP/opengnsys"
[bf41d13]1141        perl -pi -e "s/SERVERIP/$SERVERIP/g; s/DBUSER/$OPENGNSYS_DB_USER/g; s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g; s/DATABASE/$OPENGNSYS_DATABASE/g; s/OPENGNSYSURL/${OPENGNSYS_CONSOLEURL//\//\\/}/g" $INSTALL_TARGET/www/controlacceso.php
[9de73019]1142        chown $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/controlacceso.php
1143        chmod 600 $INSTALL_TARGET/www/controlacceso.php
[7b61735]1144        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/OPENGNSYSURL/${OPENGNSYS_CONSOLEURL//\//\\/}/g" $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient/ogAdmClient.cfg > $INSTALL_TARGET/client/etc/ogAdmClient.cfg
[9ee62ad]1145        echoAndLog "${FUNCNAME}(): Starting OpenGnSys services."
[cc7eab7]1146        /etc/init.d/opengnsys start
1147}
1148
[b6906f7]1149
[a01156a]1150#####################################################################
[180a07dd]1151#######  Función de resumen informativo de la instalación
1152#####################################################################
1153
[813f617]1154function installationSummary()
1155{
[eb9424f]1156        # Crear fichero de versión y revisión, si no existe.
1157        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
1158        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Revision:/ {print "r"$2}')
1159        [ -f $VERSIONFILE ] || echo "OpenGnSys" >$VERSIONFILE
1160        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
1161
1162        # Mostrar información.
[180a07dd]1163        echo
[49c6891]1164        echoAndLog "OpenGnSys Installation Summary"
[180a07dd]1165        echo       "=============================="
[eb9424f]1166        echoAndLog "Project version:                  $(cat $VERSIONFILE 2>/dev/null)"
[49c6891]1167        echoAndLog "Installation directory:           $INSTALL_TARGET"
1168        echoAndLog "Repository directory:             $INSTALL_TARGET/images"
[db3f8a3]1169        echoAndLog "DHCP configuration file:          $DHCPCONFIG"
[d47d38d]1170        echoAndLog "TFTP configuration directory:     /var/lib/tftpboot"
1171        echoAndLog "Samba configuration directory:    /etc/samba"
[49c6891]1172        echoAndLog "Web Console URL:                  $OPENGNSYS_CONSOLEURL"
[180a07dd]1173        echoAndLog "Web Console admin user:           $OPENGNSYS_DB_USER"
1174        echoAndLog "Web Console admin password:       $OPENGNSYS_DB_PASSWD"
1175        echo
1176        echoAndLog "Post-Installation Instructions:"
1177        echo       "==============================="
1178        echoAndLog "Review or edit all configuration files."
[c5ce04c]1179        echoAndLog "Insert DHCP configuration data and restart service."
[180a07dd]1180        echoAndLog "Log-in as Web Console admin user."
[85fa51e]1181        echoAndLog " - Review default Organization data and assign default user."
[180a07dd]1182        echoAndLog "Log-in as Web Console organization user."
[85fa51e]1183        echoAndLog " - Insert OpenGnSys data (rooms, computers, menus, etc)."
[180a07dd]1184echo
1185}
1186
1187
1188
1189#####################################################################
[49c6891]1190####### Proceso de instalación de OpenGnSys
[a01156a]1191#####################################################################
1192
[49c6891]1193echoAndLog "OpenGnSys installation begins at $(date)"
[6090a2d]1194pushd $WORKDIR
[cc7eab7]1195
[07c3a59]1196# Comprobar si hay conexión y detectar parámetros de red por defecto.
1197checkNetworkConnection
1198if [ $? -ne 0 ]; then
1199        errorAndLog "Error connecting to server. Causes:"
1200        errorAndLog " - Network is unreachable, review devices parameters."
1201        errorAndLog " - You are inside a private network, configure the proxy service."
1202        errorAndLog " - Server is temporally down, try agian later."
1203        exit 1
1204fi
[7586ca3]1205getNetworkSettings
1206if [ $? -ne 0 ]; then
1207        errorAndLog "Error reading default network settings."
1208        exit 1
1209fi
1210
[e0edc14]1211# Detener servicios de OpenGnSys, si están activos previamente.
1212[ -f /etc/init.d/opengnsys ] && /etc/init.d/opengnsys stop
1213
[318efac]1214# Actualizar repositorios
1215apt-get update
1216
[b6906f7]1217# Instalación de dependencias (paquetes de sistema operativo).
[a01156a]1218declare -a notinstalled
1219checkDependencies DEPENDENCIES notinstalled
1220if [ $? -ne 0 ]; then
1221        installDependencies notinstalled
1222        if [ $? -ne 0 ]; then
1223                echoAndLog "Error while installing some dependeces, please verify your server installation before continue"
1224                exit 1
1225        fi
1226fi
1227
[49c6891]1228# Arbol de directorios de OpenGnSys.
[eb9424f]1229createDirs ${INSTALL_TARGET}
[a01156a]1230if [ $? -ne 0 ]; then
1231        errorAndLog "Error while creating directory paths!"
1232        exit 1
1233fi
[b6906f7]1234
[1e7eaab]1235# Si es necesario, descarga el repositorio de código en directorio temporal
[49c6891]1236if [ $USESVN -eq 1 ]; then
[1e7eaab]1237        svnExportCode $SVN_URL
1238        if [ $? -ne 0 ]; then
1239                errorAndLog "Error while getting code from svn"
1240                exit 1
1241        fi
1242else
1243        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
[a01156a]1244fi
1245
[49c6891]1246# Compilar código fuente de los servicios de OpenGnSys.
[b6906f7]1247servicesCompilation
[13a01a7]1248if [ $? -ne 0 ]; then
1249        errorAndLog "Error while compiling OpenGnsys services"
1250        exit 1
1251fi
[b6906f7]1252
[7b61735]1253# Copiar carpeta Interface entre administración y motor de clonación.
[c1e00e4]1254copyInterfaceAdm
[7b61735]1255if [ $? -ne 0 ]; then
[c1e00e4]1256        errorAndLog "Error while copying Administration Interface"
[7b61735]1257        exit 1
1258fi
1259
[b6906f7]1260# Configurando tftp
[318efac]1261tftpConfigure
[b6906f7]1262
1263# Configuración NFS
[d47d38d]1264#### (descomentar las siguientes líneas para exportar servicios por NFS)
1265#nfsConfigure
1266#if [ $? -ne 0 ]; then
1267#       errorAndLog "Error while configuring nfs server!"
1268#       exit 1
1269#fi
[b6906f7]1270
[c1e00e4]1271# Configuración Samba
[8fc9552]1272smbConfigure
1273if [ $? -ne 0 ]; then
[c1e00e4]1274        errorAndLog "Error while configuring Samba server!"
[8fc9552]1275        exit 1
1276fi
1277
[b6906f7]1278# Configuración ejemplo DHCP
1279dhcpConfigure
[a555f49]1280if [ $? -ne 0 ]; then
1281        errorAndLog "Error while copying your dhcp server files!"
1282        exit 1
1283fi
[b6906f7]1284
[49c6891]1285# Copiar ficheros de servicios OpenGnSys Server.
[463a1d49]1286openGnsysCopyServerFiles ${INSTALL_TARGET}
1287if [ $? -ne 0 ]; then
1288        errorAndLog "Error while copying the server files!"
1289        exit 1
1290fi
1291
[49c6891]1292# Instalar Base de datos de OpenGnSys Admin.
[b6906f7]1293isInArray notinstalled "mysql-server"
1294if [ $? -eq 0 ]; then
1295        mysqlSetRootPassword ${MYSQL_ROOT_PASSWORD}
1296else
1297        mysqlGetRootPassword
1298fi
[463a1d49]1299
[a01156a]1300mysqlTestConnection ${MYSQL_ROOT_PASSWORD}
1301if [ $? -ne 0 ]; then
1302        errorAndLog "Error while connection to mysql"
1303        exit 1
1304fi
[892606b9]1305mysqlDbExists ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE}
[a01156a]1306if [ $? -ne 0 ]; then
[cc7eab7]1307        echoAndLog "Creating Web Console database"
[892606b9]1308        mysqlCreateDb ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE}
[a01156a]1309        if [ $? -ne 0 ]; then
[cc7eab7]1310                errorAndLog "Error while creating Web Console database"
[a01156a]1311                exit 1
1312        fi
1313else
[cc7eab7]1314        echoAndLog "Web Console database exists, ommiting creation"
[a01156a]1315fi
1316
[892606b9]1317mysqlCheckUserExists ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DB_USER}
[a01156a]1318if [ $? -ne 0 ]; then
1319        echoAndLog "Creating user in database"
[892606b9]1320        mysqlCreateAdminUserToDb ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE} ${OPENGNSYS_DB_USER} "${OPENGNSYS_DB_PASSWD}"
[a01156a]1321        if [ $? -ne 0 ]; then
[cc7eab7]1322                errorAndLog "Error while creating database user"
[a01156a]1323                exit 1
1324        fi
1325
1326fi
1327
[892606b9]1328mysqlCheckDbIsEmpty ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE}
[a01156a]1329if [ $? -eq 0 ]; then
1330        echoAndLog "Creating tables..."
[892606b9]1331        if [ -f $WORKDIR/$OPENGNSYS_DB_CREATION_FILE ]; then
1332                mysqlImportSqlFileToDb ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_CREATION_FILE
[a01156a]1333        else
[892606b9]1334                errorAndLog "Unable to locate $WORKDIR/$OPENGNSYS_DB_CREATION_FILE!!"
[a01156a]1335                exit 1
1336        fi
[bc7dfe7]1337else
1338        # Si existe fichero ogBDAdmin-VersLocal-VersRepo.sql; aplicar cambios.
1339        INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
1340        REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
[295b4ab]1341        OPENGNSYS_DB_UPDATE_FILE="opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
1342        if [ -f $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE ]; then
[bc7dfe7]1343                echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
[295b4ab]1344                mysqlImportSqlFileToDb ${MYSQL_ROOT_PASSWORD} ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE
[bc7dfe7]1345        else
1346                echoAndLog "Database unchanged."
1347        fi
[a01156a]1348fi
1349
1350# copiando paqinas web
[7586ca3]1351installWebFiles
[5d6bf97]1352# Generar páqinas web de documentación de la API
1353makeDoxygenFiles
[a01156a]1354
1355# creando configuracion de apache2
[892606b9]1356openGnsysInstallWebConsoleApacheConf $INSTALL_TARGET /etc/apache2
[a01156a]1357if [ $? -ne 0 ]; then
[49c6891]1358        errorAndLog "Error configuring Apache for OpenGnSYS Admin"
[a01156a]1359        exit 1
1360fi
1361
1362popd
[892606b9]1363
[9ef8920]1364
1365# Crear la estructura de los accesos al servidor desde el cliente (shared)
[7cc6687]1366openGnsysCopyClientFiles
[9ef8920]1367if [ $? -ne 0 ]; then
1368        errorAndLog "Error creating client structure"
1369fi
1370
[813f617]1371# Crear la estructura del antiguo cliente initrd de OpenGnSys 0.10
[d47d38d]1372#### (descomentar las siguientes líneas para generar cliente initrd)
[2338c95f]1373#openGnsysOldClientCreate
1374#if [ $? -ne 0 ]; then
1375#       errorAndLog "Warning: cannot create old initrd client"
1376#fi
[9ef8920]1377
[813f617]1378# Crear la estructura del cliente de OpenGnSys 1.0
[892606b9]1379openGnsysClientCreate
[a555f49]1380if [ $? -ne 0 ]; then
[813f617]1381        errorAndLog "Error creating client"
[a555f49]1382        exit 1
1383fi
[892606b9]1384
[65245d1]1385# Configuración de servicios de OpenGnSys
1386openGnsysConfigure
1387
[180a07dd]1388# Mostrar sumario de la instalación e instrucciones de post-instalación.
1389installationSummary
1390
[077dd7c5]1391#rm -rf $WORKDIR
[49c6891]1392echoAndLog "OpenGnSys installation finished at $(date)"
[2308fc7]1393
Note: See TracBrowser for help on using the repository browser.